// Lst.h
/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _LST_H
#define _LST_H

	typedef struct lststruct
	{
		struct lststruct *next;
	} LST;

	typedef struct lstnumstruct
	{
		struct lstnumstruct *next;
		long num;
	} LSTNUM;

	typedef struct lstcharstruct
	{
		struct lstcharstruct *next;
		char s[0];
	} LSTCHAR;

	typedef struct lstcharptrstruct
	{
		struct lstcharptrstruct *next;
		char *s;
	} LSTCHARPTR;


class Lst {
public:
	Lst(void);
	~Lst(void);
	void addlist(void *it);
	void removelist(void *it);
	void *num2ptr(long num);
	void *char2ptr(char *s);
	void *charptr2ptr(char *s);
	long len(void);
	void *listbase(void) {
		return base;
	}

private:
	LST *base;
	long qty;
};

#endif // _LST_H
