// Value.cpp
/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <string.h>

#include "Value.h"


void Value::addpair(char *n,char *val)
{
	VALUE *v = new VALUE;

	v -> name = new char[strlen(n) + 1];
	strcpy(v -> name,n);
	v -> value = new char[strlen(val) + 1];
	strcpy(v -> value,val);
	addlist(v);
}


/* get names */

void Value::getfirst(char *n,short len)
{
	current = (VALUE *)listbase();
	getnext(n,len);
}

void Value::getnext(char *n,short len)
{
	if (current)
	{
		strncpy(n,current -> name,len - 1);
		n[len - 1] = 0;
		current = current -> next;
	} else
		*n = 0;
}

/* get value */
int Value::getvalue(char *n,char *v,short len)
{
	VALUE *value;
	int r = 0;

	value = (VALUE *)charptr2ptr(n);
	if (value)
	{
		strncpy(v,value -> value,len - 1);
		v[len - 1] = 0;
		r++;
	} else
		*v = 0;

	return r;
}

int Value::getlength(char *n)
{
	VALUE *value;

	value = (VALUE *)charptr2ptr(n);
	return value ? strlen(value -> value) : 0;
}

